System.register(["__unresolved_0", "cc", "__unresolved_1", "__unresolved_2", "__unresolved_3"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, Vec3, Animation, RigidBody, geometry, PhysicsSystem, Input, KeyCode, SmartFootstepSystem, PersonState, _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _crd, ccclass, property, ThirdPersonController;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfInput(extras) {
    _reporterNs.report("Input", "../InputManager", _context.meta, extras);
  }

  function _reportPossibleCrUseOfKeyCode(extras) {
    _reporterNs.report("KeyCode", "../InputManager", _context.meta, extras);
  }

  function _reportPossibleCrUseOfSmartFootstepSystem(extras) {
    _reporterNs.report("SmartFootstepSystem", "../system/SmartFootstepSystem", _context.meta, extras);
  }

  function _reportPossibleCrUseOfPersonState(extras) {
    _reporterNs.report("PersonState", "./PersonState", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Vec3 = _cc.Vec3;
      Animation = _cc.Animation;
      RigidBody = _cc.RigidBody;
      geometry = _cc.geometry;
      PhysicsSystem = _cc.PhysicsSystem;
    }, function (_unresolved_2) {
      Input = _unresolved_2.Input;
      KeyCode = _unresolved_2.KeyCode;
    }, function (_unresolved_3) {
      SmartFootstepSystem = _unresolved_3.SmartFootstepSystem;
    }, function (_unresolved_4) {
      PersonState = _unresolved_4.PersonState;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "280d3rUOs9Iaa/6wdET2TDz", "ThirdPersonController", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("ThirdPersonController", ThirdPersonController = (_dec = ccclass('ThirdPersonController'), _dec2 = property(), _dec3 = property(), _dec(_class = (_class2 = class ThirdPersonController extends Component {
        constructor() {
          super(...arguments);

          _initializerDefineProperty(this, "moveSpeed", _descriptor, this);

          _initializerDefineProperty(this, "roatSpeed", _descriptor2, this);

          this.animation = null;
          this._state = (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
            error: Error()
          }), PersonState) : PersonState).idle;
          this.groundCheckDistance = 0.5;
          this.footStepTime = 0;
          this.footstepRate = 0.5;
          this.smartFootstepSystem = null;
        }

        get state() {
          return this._state;
        }

        set state(value) {
          var _this$animation, _this$animation2;

          if (this._state == value) {
            return;
          }

          this._state = value;

          switch (this._state) {
            case (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
              error: Error()
            }), PersonState) : PersonState).idle:
              (_this$animation = this.animation) == null ? void 0 : _this$animation.crossFade("Idle");
              break;

            case (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
              error: Error()
            }), PersonState) : PersonState).walk:
              (_this$animation2 = this.animation) == null ? void 0 : _this$animation2.crossFade("Move");
              break;
          }
        }

        start() {
          // [3]
          this.animation = this.getComponentInChildren(Animation);
          this.smartFootstepSystem = this.getComponent(_crd && SmartFootstepSystem === void 0 ? (_reportPossibleCrUseOfSmartFootstepSystem({
            error: Error()
          }), SmartFootstepSystem) : SmartFootstepSystem);
        }

        update(deltaTime) {
          // [4]
          var isGround = this.checkGround();

          if ((_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).getKeyDown((_crd && KeyCode === void 0 ? (_reportPossibleCrUseOfKeyCode({
            error: Error()
          }), KeyCode) : KeyCode).Space)) {
            if (isGround) {
              var _this$getComponent;

              (_this$getComponent = this.getComponent(RigidBody)) == null ? void 0 : _this$getComponent.applyForce(new Vec3(0, 360, 0));
            }
          }

          var eulerAngles = this.node.eulerAngles;
          eulerAngles.y += -(_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).axis.x * this.roatSpeed * deltaTime;
          this.node.eulerAngles = eulerAngles;
          this.node.translate(new Vec3(0, 0, (_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).axis.y * this.moveSpeed * deltaTime));

          if (this.animation) {
            if ((_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
              error: Error()
            }), Input) : Input).axis.y != 0) {
              this.state = (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
                error: Error()
              }), PersonState) : PersonState).walk;
            } else {
              this.state = (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
                error: Error()
              }), PersonState) : PersonState).idle;
            }
          }

          if ((_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).axis.y != 0) {
            if (isGround) {
              this.footStepTime -= deltaTime;

              if (this.footStepTime <= 0) {
                this.footStepTime = this.footstepRate; //走了一步

                this.smartFootstepSystem && this.smartFootstepSystem.footStep();
              }
            }
          }
        }

        checkGround() {
          var ray = new geometry.Ray();
          ray.o = new Vec3(this.node.worldPosition.x, this.node.worldPosition.y + 0.1, this.node.worldPosition.z);
          ray.d = new Vec3(0, -1, 0);

          if (PhysicsSystem.instance.raycastClosest(ray, 0xffffffff, this.groundCheckDistance)) {
            var rayResult = PhysicsSystem.instance.raycastClosestResult;

            if (rayResult.collider) {
              //console.log("rayResult.collider",rayResult.collider);
              return true;
            }
          }

          return false;
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "moveSpeed", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return 2.0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "roatSpeed", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return 120;
        }
      })), _class2)) || _class));
      /**
       * [1] Class member could be defined like this.
       * [2] Use `property` decorator if your want the member to be serializable.
       * [3] Your initialization goes here.
       * [4] Your update function goes here.
       *
       * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
       * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
       * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
       */


      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=a07530fa45e6867ef228533983a4194bf890fc07.js.map