System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, Mathf, _crd;

  _export("default", void 0);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "02298aN/ihKRrSN3vjDCiWF", "Mathf", undefined);

      // Learn TypeScript:
      //  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
      //  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
      // Learn Attribute:
      //  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
      //  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
      // Learn life-cycle callbacks:
      //  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
      //  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html
      _export("default", Mathf = class Mathf {
        /**
         * 角度转弧度
         */

        /**
         * 弧度转角度
         */

        /**
         * 获得随机方向
         */
        static sign(x) {
          if (x > 0) {
            return 1;
          }

          if (x < 0) {
            return -1;
          }

          return 0;
        }
        /**
         * 插值
         * @param numStart 
         * @param numEnd 
         * @param t 
         */


        static lerp(numStart, numEnd, t) {
          if (t > 1) {
            t = 1;
          } else if (t < 0) {
            t = 0;
          }

          return numStart * (1 - t) + numEnd * t;
        }
        /**
         * 
         * @param angle1 角度插值
         * @param angle2 
         * @param t 
         */


        static lerpAngle(current, target, t) {
          current %= 360;
          target %= 360;
          var dAngle = target - current;

          if (dAngle > 180) {
            target = current - (360 - dAngle);
          } else if (dAngle < -180) {
            target = current + (360 + dAngle);
          }

          return (Mathf.lerp(current, target, t) % 360 + 360) % 360;
        }
        /**
         * 按一定的速度从一个角度转向令一个角度
         * @param current 
         * @param target 
         * @param speed 
         */


        static angleTowards(current, target, speed) {
          current %= 360;
          target %= 360;
          var dAngle = target - current;

          if (dAngle > 180) {
            target = current - (360 - dAngle);
          } else if (dAngle < -180) {
            target = current + (360 + dAngle);
          }

          var dir = target - current;

          if (speed > Math.abs(dir)) {
            return target;
          }

          return ((current + speed * Math.sign(dir)) % 360 + 360) % 360;
        }

        static clamp(value, minLimit, maxLimit) {
          if (value < minLimit) {
            return minLimit;
          }

          if (value > maxLimit) {
            return maxLimit;
          }

          return value;
        }
        /**
         * 
         * @param value 获得一个值的概率
         */


        static probability(value) {
          return Math.random() < value;
        }

      });

      Mathf.deg2Rad = Math.PI / 180;
      Mathf.rad2Deg = 180 / Math.PI;

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=eab39d72a913116110ce8e0d1100f806454c70df.js.map