System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, CCString, Texture2D, AudioClip, AudioSource, Terrain, geometry, Vec3, PhysicsSystem, MeshRenderer, Input, KeyCode, _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _dec5, _dec6, _dec7, _dec8, _dec9, _class4, _class5, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _crd, ccclass, property, GroundType, SmartFootstepSystem;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfInput(extras) {
    _reporterNs.report("Input", "../InputManager", _context.meta, extras);
  }

  function _reportPossibleCrUseOfKeyCode(extras) {
    _reporterNs.report("KeyCode", "../InputManager", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      CCString = _cc.CCString;
      Texture2D = _cc.Texture2D;
      AudioClip = _cc.AudioClip;
      AudioSource = _cc.AudioSource;
      Terrain = _cc.Terrain;
      geometry = _cc.geometry;
      Vec3 = _cc.Vec3;
      PhysicsSystem = _cc.PhysicsSystem;
      MeshRenderer = _cc.MeshRenderer;
    }, function (_unresolved_2) {
      Input = _unresolved_2.Input;
      KeyCode = _unresolved_2.KeyCode;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "c723coXmWxOgrE742b3oHi7", "SmartFootstepSystem", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("GroundType", GroundType = (_dec = ccclass("GroundType"), _dec2 = property({
        type: CCString
      }), _dec3 = property({
        type: Texture2D
      }), _dec4 = property(AudioClip), _dec(_class = (_class2 = class GroundType {
        constructor() {
          _initializerDefineProperty(this, "name", _descriptor, this);

          _initializerDefineProperty(this, "texture", _descriptor2, this);

          _initializerDefineProperty(this, "clip", _descriptor3, this);
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "name", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "texture", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "clip", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _export("SmartFootstepSystem", SmartFootstepSystem = (_dec5 = ccclass('SmartFootstepSystem'), _dec6 = property(AudioSource), _dec7 = property(GroundType), _dec8 = property(Terrain), _dec9 = property(), _dec5(_class4 = (_class5 = class SmartFootstepSystem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "footstepAudio", _descriptor4, this);

          _initializerDefineProperty(this, "groundTypes", _descriptor5, this);

          _initializerDefineProperty(this, "terrain", _descriptor6, this);

          _initializerDefineProperty(this, "groundCheckDistance", _descriptor7, this);
        }

        start() {// [3]
          //this.terrain.getBlock(0,0).getLayer(0).
          //this.terrain._asset
        }

        update(deltaTime) {
          // [4]
          if ((_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).getKeyDown((_crd && KeyCode === void 0 ? (_reportPossibleCrUseOfKeyCode({
            error: Error()
          }), KeyCode) : KeyCode).T)) {
            console.log("地面贴图？", this.getRendererTexture());
          }
        }

        footStep() {
          this.footstepAudio.playOneShot(this.groundTypes[0].clip);
        }

        getRendererTexture() {
          var ray = new geometry.Ray();
          ray.o = new Vec3(this.node.worldPosition.x, this.node.worldPosition.y + 0.1, this.node.worldPosition.z);
          ray.d = new Vec3(0, -1, 0);

          if (PhysicsSystem.instance.raycastClosest(ray, 0xffffffff, this.groundCheckDistance)) {
            var rayResult = PhysicsSystem.instance.raycastClosestResult;
            console.log("地面", rayResult.collider.node);
            var renderer = rayResult.collider.getComponent(MeshRenderer);
            console.log("renderer", renderer);

            if (renderer) {
              //console.log("rayResult.collider",rayResult.collider);
              return true;
            }
          }
        }

      }, (_descriptor4 = _applyDecoratedDescriptor(_class5.prototype, "footstepAudio", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class5.prototype, "groundTypes", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class5.prototype, "terrain", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class5.prototype, "groundCheckDistance", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 1;
        }
      })), _class5)) || _class4));
      /**
       * [1] Class member could be defined like this.
       * [2] Use `property` decorator if your want the member to be serializable.
       * [3] Your initialization goes here.
       * [4] Your update function goes here.
       *
       * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
       * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
       * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
       */


      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=8969611f2e9bdd93cd6f5d0a2d273af8512589ac.js.map