System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, Node, Size, view, Vec2, game, Canvas, _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _class3, _crd, ccclass, property, GameController;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      Size = _cc.Size;
      view = _cc.view;
      Vec2 = _cc.Vec2;
      game = _cc.game;
      Canvas = _cc.Canvas;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "f555eTiwnNMY7prL/pHjeRN", "GameController", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("GameController", GameController = (_dec = ccclass('GameController'), _dec2 = property(Node), _dec3 = property(Canvas), _dec(_class = (_class2 = (_class3 = class GameController extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "touchPlane", _descriptor, this);

          _initializerDefineProperty(this, "canvas", _descriptor2, this);

          this.mouseAxis = new Vec2();
          this.referenceWidth = 750;
          this.referenceHeight = 1334;
          this.widthRatio = 1;
          this.heightRatio = 1;
          this.m_rateTouch = 960;
          this.angleY = 0;
          this.targetAngleY = 0;
          this.angleSpeed = 20;
          this.lerpSpeed = 1.5;
          this.screenSize = new Size();
          this.isLockMouse = false;
        }

        onLoad() {
          if (GameController.instance) {
            this.node.destroy();
            return;
          }

          GameController.instance = this;
          game.addPersistRootNode(this.node);
          this.screenSize.width = view.getVisibleSize().width;
          this.screenSize.height = view.getVisibleSize().height;
          this.widthRatio = this.referenceWidth / this.screenSize.width;
          this.heightRatio = this.referenceHeight / this.screenSize.height; //print("widthRatio " + widthRatio + "   heightRatio " + heightRatio);
          //print("Screen.width " + Screen.width + "   Screen.height " + Screen.height);
          //控制不同分辨率的旋转系数

          if (this.screenSize.width <= 480) {
            this.m_rateTouch = 960;
          } else if (this.screenSize.width > 1080) {
            this.m_rateTouch = 960;
          }
        }

        start() {
          if (this.touchPlane) {
            this.touchPlane.on(Node.EventType.TOUCH_START, event => {}, this, true);
            this.touchPlane.on(Node.EventType.MOUSE_MOVE, event => {
              this.mouseAxis = event.getUIDelta();
            }, this, true);
            this.touchPlane.on(Node.EventType.TOUCH_END, event => {}, this, true);
            this.touchPlane.on(Node.EventType.TOUCH_CANCEL, event => {}, this, true);
          }

          if (game.canvas) {
            //game.canvas.requestFullscreen()
            game.canvas.requestPointerLock();
            game.canvas.addEventListener('click', () => {
              if (document.pointerLockElement) {
                document.exitPointerLock();
              } else {
                game.canvas.requestPointerLock();
              }
            });
            var self = this;

            function onMouseMove(e) {
              //console.log("e",e.x,e.y,e.clientX,e.clientY,e.screenX,e.screenY,e.pageX,e.pageY,game.canvas.offsetLeft,game.canvas.offsetTop);

              /*let node = self.canvas.node.children[0];
              
              var pos:Vec3 = node.position;
                pos.x += e.movementX;
              pos.y -= e.movementY;*/
              self.mouseAxis.x = e.movementX;
              self.mouseAxis.y = -e.movementY; //node.position = pos;
            } // 检测鼠标锁定状态变化


            document.addEventListener('pointerlockchange', () => {
              //console.log('pointerlockchange: ', document.pointerLockElement)
              if (document.pointerLockElement) {
                this.isLockMouse = true;
                console.log("锁定鼠标");
                game.canvas.addEventListener("mousemove", onMouseMove, false);
              } else {
                game.canvas.removeEventListener("mousemove", onMouseMove, false);
                console.log("解除锁定鼠标");
              }
            }, false);
          }
        }
        /*update (deltaTime: number) {
            
          }*/


        lateUpdate() {
          this.mouseAxis.x = 0;
          this.mouseAxis.y = 0;
        }

        onDestroy() {}

      }, _class3.instance = void 0, _class3), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "touchPlane", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "canvas", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));
      /**
       * [1] Class member could be defined like this.
       * [2] Use `property` decorator if your want the member to be serializable.
       * [3] Your initialization goes here.
       * [4] Your update function goes here.
       *
       * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
       * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
       * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
       */


      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=e62dd06f8fb9fb8c21800fc04ba7640b77d80b6f.js.map