System.register(["__unresolved_0", "cc", "__unresolved_1", "__unresolved_2", "__unresolved_3"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, geometry, Vec3, PhysicsSystem, CapsuleCollider, RigidBody, Input, KeyCode, SmartFootstepSystem, PersonState, _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _crd, ccclass, property, FirstPersonController;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfInput(extras) {
    _reporterNs.report("Input", "../InputManager", _context.meta, extras);
  }

  function _reportPossibleCrUseOfKeyCode(extras) {
    _reporterNs.report("KeyCode", "../InputManager", _context.meta, extras);
  }

  function _reportPossibleCrUseOfSmartFootstepSystem(extras) {
    _reporterNs.report("SmartFootstepSystem", "../system/SmartFootstepSystem", _context.meta, extras);
  }

  function _reportPossibleCrUseOfPersonState(extras) {
    _reporterNs.report("PersonState", "./PersonState", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      geometry = _cc.geometry;
      Vec3 = _cc.Vec3;
      PhysicsSystem = _cc.PhysicsSystem;
      CapsuleCollider = _cc.CapsuleCollider;
      RigidBody = _cc.RigidBody;
    }, function (_unresolved_2) {
      Input = _unresolved_2.Input;
      KeyCode = _unresolved_2.KeyCode;
    }, function (_unresolved_3) {
      SmartFootstepSystem = _unresolved_3.SmartFootstepSystem;
    }, function (_unresolved_4) {
      PersonState = _unresolved_4.PersonState;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "efec9nv5/BHHaSJ9Wt2WiuZ", "FirstPersonController", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("FirstPersonController", FirstPersonController = (_dec = ccclass('FirstPersonController'), _dec2 = property(), _dec3 = property(), _dec4 = property(), _dec(_class = (_class2 = class FirstPersonController extends Component {
        constructor() {
          super(...arguments);
          this.state = (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
            error: Error()
          }), PersonState) : PersonState).idle;

          _initializerDefineProperty(this, "defaultMoveSpeed", _descriptor, this);

          _initializerDefineProperty(this, "runMultiplier", _descriptor2, this);

          _initializerDefineProperty(this, "defaultFootstepRate", _descriptor3, this);

          this.footStepTime = 0;
          this.moveSpeed = 1.0;
          this.footstepRate = 0.5;
          this.groundCheckDistance = 0.5;
          this.smartFootstepSystem = null;
        }

        start() {
          // [3]
          this.groundCheckDistance = this.getComponent(CapsuleCollider).height / 2 + 0.25; //console.log("检测距离",this.groundCheckDistance);

          this.moveSpeed = this.defaultMoveSpeed;
          this.footstepRate = this.defaultFootstepRate;
          this.smartFootstepSystem = this.getComponent(_crd && SmartFootstepSystem === void 0 ? (_reportPossibleCrUseOfSmartFootstepSystem({
            error: Error()
          }), SmartFootstepSystem) : SmartFootstepSystem);
        }

        update(deltaTime) {
          // [4]
          if ((_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).getKeyDown((_crd && KeyCode === void 0 ? (_reportPossibleCrUseOfKeyCode({
            error: Error()
          }), KeyCode) : KeyCode).Q)) {
            console.log("是否接触地面？", this.checkGround());
          }

          var isGround = this.checkGround();

          if ((_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).getKeyDown((_crd && KeyCode === void 0 ? (_reportPossibleCrUseOfKeyCode({
            error: Error()
          }), KeyCode) : KeyCode).Space)) {
            if (isGround) {
              var _this$getComponent;

              (_this$getComponent = this.getComponent(RigidBody)) == null ? void 0 : _this$getComponent.applyForce(new Vec3(0, 480, 0));
            }
          }

          if ((_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).axis.x != 0 || (_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
            error: Error()
          }), Input) : Input).axis.y != 0) {
            if ((_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
              error: Error()
            }), Input) : Input).getKey((_crd && KeyCode === void 0 ? (_reportPossibleCrUseOfKeyCode({
              error: Error()
            }), KeyCode) : KeyCode).Shift)) {
              this.state = (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
                error: Error()
              }), PersonState) : PersonState).run;
              this.moveSpeed = this.defaultMoveSpeed * this.runMultiplier;
              this.footstepRate = this.defaultFootstepRate / this.runMultiplier;
            } else {
              this.state = (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
                error: Error()
              }), PersonState) : PersonState).walk;
              this.moveSpeed = this.defaultMoveSpeed;
              this.footstepRate = this.defaultFootstepRate;
            }

            if (isGround) {
              this.footStepTime -= deltaTime;

              if (this.footStepTime <= 0) {
                this.footStepTime = this.footstepRate; //走了一步

                this.smartFootstepSystem && this.smartFootstepSystem.footStep();
              }
            }

            this.node.translate(new Vec3(-(_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
              error: Error()
            }), Input) : Input).axis.x * (this.moveSpeed / 2) * deltaTime, 0, (_crd && Input === void 0 ? (_reportPossibleCrUseOfInput({
              error: Error()
            }), Input) : Input).axis.y * this.moveSpeed * deltaTime));
          } else {
            this.state = (_crd && PersonState === void 0 ? (_reportPossibleCrUseOfPersonState({
              error: Error()
            }), PersonState) : PersonState).idle;
          }
        }

        checkGround() {
          var ray = new geometry.Ray();
          ray.o = new Vec3(this.node.worldPosition.x, this.node.worldPosition.y + 0.1, this.node.worldPosition.z);
          ray.d = new Vec3(0, -1, 0);

          if (PhysicsSystem.instance.raycastClosest(ray, 0xffffffff, this.groundCheckDistance)) {
            var rayResult = PhysicsSystem.instance.raycastClosestResult;

            if (rayResult.collider) {
              //console.log("rayResult.collider",rayResult.collider);
              return true;
            }
          }

          return false;
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "defaultMoveSpeed", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return 1.0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "runMultiplier", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return 2.0;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "defaultFootstepRate", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return 0.5;
        }
      })), _class2)) || _class));
      /**
       * [1] Class member could be defined like this.
       * [2] Use `property` decorator if your want the member to be serializable.
       * [3] Your initialization goes here.
       * [4] Your update function goes here.
       *
       * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
       * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
       * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
       */


      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=6f1e16a22239c6660ba479eaa03fccbcba6be863.js.map